/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use client";"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const zt=require("react"),L=require("prop-types"),o=require("@progress/kendo-react-common"),Bt=require("@progress/kendo-react-labels"),Ze=require("@progress/kendo-svg-icons"),_t=require("../common/ListContainer.js"),Ht=require("../common/ListFilter.js"),et=require("../common/GroupStickyHeader.js"),Wt=require("../common/ListDefaultItem.js"),Ut=require("../common/List.js"),nt=require("../common/DropDownBase.js"),p=require("../common/utils.js"),Gt=require("../package-metadata.js"),tt=require("@progress/kendo-react-buttons"),jt=require("@progress/kendo-react-intl"),Ke=require("../messages/index.js"),ke=require("@progress/kendo-react-layout");function Rt(h){const R=Object.create(null,{[Symbol.toStringTag]:{value:"Module"}});if(h){for(const N in h)if(N!=="default"){const B=Object.getOwnPropertyDescriptor(h,N);Object.defineProperty(R,N,B.get?B:{enumerable:!0,get:()=>h[N]})}}return R.default=h,Object.freeze(R)}const s=Rt(zt),Yt="Please select a value from the list!",pe=s.forwardRef((h,R)=>{o.validatePackage(Gt.packageMetadata);const N=o.useUnstyled(),B=o.useId(h.id),r=o.usePropsContext(rt,h),{delay:ot=F.delay,tabIndex:at=F.tabIndex,ignoreCase:me=F.ignoreCase,size:Y=F.size,rounded:Pe=F.rounded,fillMode:ge=F.fillMode,groupMode:$t=F.groupMode}=r,fe=()=>{if(o.canUseDOM)return H.current&&H.current.ownerDocument||window.document},st=()=>{var e,n;(e=t==null?void 0:t.current)!=null&&e.wrapper&&((n=t==null?void 0:t.current)==null||n.wrapper.focus({preventScroll:!0}))},K=()=>{let e;return T.current!==void 0&&T.current!==null?e=T.current:r.value!==void 0?e=r.value:f.value!==void 0&&f.value!==null?e=f.value:r.defaultValue!==void 0&&r.defaultValue!==null&&(e=r.defaultValue),!p.isPresent(e)&&r.defaultItem!==void 0&&r.defaultItem!==null&&(e=r.defaultItem),e},it=()=>{const{dataItemKey:e}=r,n=p.getFilteredData(h),i=K();return n.findIndex(u=>p.areSame(u,i,e))},ve=()=>r.required!==void 0?r.required:F.required,De=()=>{const e=r.validationMessage!==void 0,n=K(),i=!ve()||n!==null&&n!==""&&n!==void 0,u=r.valid!==void 0?r.valid:i;return{customError:e,valid:u,valueMissing:n===null}},lt=()=>r.validityStyles!==void 0?r.validityStyles:F.validityStyles,ee=e=>{ne.current=!0,e.focus(),window.setTimeout(()=>ne.current=!1,30)},we=()=>{J.current&&ee(J.current),r.adaptive&&setTimeout(()=>{J.current&&ee(J.current)},300)},dt=e=>{for(const n of e)n.target.clientWidth!==re.current.windowWidth&&U({windowWidth:n.target.clientWidth})},be=()=>{te.current&&te.current.setCustomValidity&&te.current.setCustomValidity(De().valid?"":r.validationMessage||Yt)},_=(e,n)=>{const i=K();p.areSame(i,e,r.dataItemKey)||(r.value===void 0&&(n.data.value=e),t.current.updateComponentArgs({value:e}),T.current=e,n.events.push({type:"onChange"}))},P=e=>{var n;(n=t==null?void 0:t.current)==null||n.applyState(e),T.current=void 0},$=(e,n)=>{var d;const{virtual:i,dataItemKey:u,defaultItem:c}=r,m=p.getFilteredData(h),I=i?i.skip:0,v=K(),a=e===-1&&c!==void 0?c:m[e-I],g=!p.areSame(a,v,u);_(a,n),g&&((d=t==null?void 0:t.current)==null||d.triggerPageChangeCornerItems(a,n))},A=(e,n,i)=>{var x,D;const{defaultItem:u,dataItemKey:c,virtual:m={skip:0,total:0,pageSize:0}}=r,I=K(),v=p.getFilteredData(h),a=(x=t==null?void 0:t.current)==null?void 0:x.vs,g=v.findIndex(y=>p.areSame(y,I,c)),d=(D=t==null?void 0:t.current)==null?void 0:D.navigation.navigate({current:m.skip+g,max:(a!=null&&a.enabled?m.total:v.length)-1,min:u!==void 0?-1:0,keyCode:n,skipItems:i||void 0});d!==void 0&&$(d,e),P(e)},ct=e=>{H.current=e,t.current.wrapper=e},ut=e=>s.createElement("select",{name:r.name,ref:n=>{te.current=n},tabIndex:-1,"aria-hidden":!0,title:r.label,style:{opacity:0,width:1,border:0,zIndex:-1,position:"absolute",left:"50%"}},s.createElement("option",{value:r.valueMap?r.valueMap.call(void 0,e):e})),Ie=()=>{const{textField:e,dataItemKey:n,virtual:i={skip:0},focusedItemIndex:u=p.itemIndexStartsWith,filterable:c,skipDisabledItems:m=!0}=r,I=K(),v=p.getFilteredData(h),a=r.filter?r.filter:f.text;return m&&e&&!a&&!I?v.findIndex(g=>!g.disabled&&g[e]):p.isPresent(I)&&a===void 0||c&&a===""?v.findIndex(g=>p.areSame(g,I,n)):a?Se.current?u(v,a,e):v.findIndex(g=>p.areSame(g,I,n)):i.skip===0?0:-1},Fe=(e,n)=>n!==void 0&&n!==-1&&e&&e.length>0&&e[n].disabled,ye=()=>{const e=p.getFilteredData(h),n=t.current.initState(),i=Ie();Fe(e,i)&&(_(null,n),P(n))},he=e=>{if(e.isPropagationStopped())return;const n=t.current.initState();n.syntheticEvent=e,f.focused||(n.data.focused=!0),ye(),t.current.togglePopup(n),P(n)},Me=e=>{var M,ce,z,ue,j,Qe,Xe;e&&e.target instanceof Element&&e.target.nodeName==="INPUT"&&e.stopPropagation&&e.stopPropagation();const{filterable:n,disabled:i,defaultItem:u,leftRightKeysNavigation:c=!0,virtual:m={skip:0,total:0,pageSize:0},dataItemKey:I,groupField:v="",textField:a,skipDisabledItems:g=!0}=r,d=p.getFilteredData(h),x=K(),D=d.findIndex(E=>p.areSame(E,x,I)),y=r.opened!==void 0?r.opened:f.opened,l=e.keyCode,b=l===o.Keys.home||l===o.Keys.end,k=l===o.Keys.up||l===o.Keys.down,G=!y&&(e.altKey&&l===o.Keys.down||l===o.Keys.enter||l===o.Keys.space),Z=y&&(e.altKey&&l===o.Keys.up||l===o.Keys.esc),le=c&&(l===o.Keys.left||l===o.Keys.right),de=k||le&&!n||b,C=t.current.initState();if(C.syntheticEvent=e,!i){if(b&&((M=t==null?void 0:t.current)!=null&&M.vs.enabled))l===o.Keys.home?m.skip!==0?((ce=t==null?void 0:t.current)==null||ce.triggerOnPageChange(C,0,m.pageSize),O.current=!0):_(d[0],C):m.skip<m.total-m.pageSize?((z=t==null?void 0:t.current)==null||z.triggerOnPageChange(C,m.total-m.pageSize,m.pageSize),O.current=!0):_(d[d.length-1],C);else if(y&&l===o.Keys.pageUp)e.preventDefault(),(ue=t==null?void 0:t.current)==null||ue.scrollPopupByPageSize(-1);else if(y&&l===o.Keys.pageDown)e.preventDefault(),(j=t==null?void 0:t.current)==null||j.scrollPopupByPageSize(1);else if(y&&l===o.Keys.enter){const E=Ie();Fe(d,E)?(_(null,C),P(C)):$(E,C),(Qe=t==null?void 0:t.current)==null||Qe.togglePopup(C),e.preventDefault()}else if(G||Z)Z&&ye(),(Xe=t==null?void 0:t.current)==null||Xe.togglePopup(C),e.preventDefault();else if(de){if(Se.current=!1,v!==""&&a)if(!g&&y)A(C,l);else{let E;if(l===o.Keys.down||l===o.Keys.right){const S=d.slice(D+1).find(w=>!w.disabled&&w[a]);E=S&&d.findIndex(w=>w[a]===S[a])}else if(l===o.Keys.up||l===o.Keys.left){let S;if(D===0&&u)E=-1;else if(D===-1)S=d,E=d.findIndex(w=>!w.disabled&&w[a]);else{S=d.slice(0,D);let w=S.pop();for(;w&&w.disabled;)w=S.pop();E=w&&d.findIndex(Ne=>Ne[a]===w[a])}}if(E!==void 0){const S=E-D;A(C,l,S)}else E===void 0&&d.findIndex(S=>S[a]===x[a])===d.length-1&&A(C,l)}else if(!g&&y||b)A(C,l);else if(a){let E;if(l===o.Keys.down||l===o.Keys.right){const S=d.slice(D+1).find(w=>!w.disabled&&w[a]);E=S&&d.findIndex(w=>w[a]===S[a])}else if(l===o.Keys.up||l===o.Keys.left){let S;if(D===0&&u)E=-1;else if(D===-1)S=d,E=d.find(w=>!w.disabled&&w[a]);else{S=d.slice(0,D);let w=S.pop();for(;w&&w.disabled;)w=S.pop();E=w&&d.findIndex(Ne=>Ne[a]===w[a])}}if(E!==void 0){const S=E-D;A(C,l,S)}else E===void 0&&d.findIndex(S=>S[a]===x[a])===d.length-1&&A(C,l)}else A(C,l);e.preventDefault()}P(C)}},pt=e=>{const n=t.current.initState();n.syntheticEvent=e.syntheticEvent,r.filter===void 0&&(n.data.text=e.target.value),t.current.filterChanged(e.target.value,n),Se.current=!0,P(n),U({group:void 0,text:String(e.target.value)})},Ae=()=>{const e=r.filter!==void 0?r.filter:f.text;return r.filterable&&s.createElement(Ht,{value:e,ref:n=>J.current=n&&n.element,onChange:pt,onKeyDown:Me,size:Y,rounded:Pe,fillMode:ge,renderListFilterWrapper:!0})},mt=e=>{var i;const n=t.current.initState();n.syntheticEvent=e,(i=t==null?void 0:t.current)==null||i.togglePopup(n),_(r.defaultItem,n),P(n)},Te=()=>{const{textField:e,defaultItem:n,dataItemKey:i}=r,u=K();return n!==void 0&&s.createElement(Wt,{defaultItem:n,textField:e,selected:p.areSame(u,n,i),key:"defaultitemkey",onClick:mt})},gt=(e,n)=>{var i;(i=t==null?void 0:t.current)==null||i.handleItemClick(e,n),T.current=void 0},ft=e=>{const{vs:n,list:i}=t.current;n.scrollHandler(e);const{groupField:u}=r;let c=p.getFilteredData(h);if(!(!u||!c.length)&&u){const m=ze.current=ze.current||(n.enabled?n.itemHeight:i?i.children[0].offsetHeight:0),v=e.target.scrollTop-n.skip*m;c=t.current.getGroupedDataModernMode(c,u);let a=c[0][u];for(let g=1;g<c.length&&!(m*g>v);g++)c[g]&&c[g][u]&&(a=c[g][u]);a!==f.group&&U({group:a})}},Oe=()=>{var l;const{textField:e,dataItemKey:n,virtual:i={skip:0,total:void 0},groupHeaderItemRender:u,listNoDataRender:c,itemRender:m}=r,I=p.getFilteredData(h),v=N&&N.uDropDownList,a=t.current.vs,g=i.skip,d=r.opened!==void 0?r.opened:f.opened,x=t.current.getPopupSettings(),D=`translateY(${a.translate}px)`,y=K();return s.createElement(Ut,{id:xe,show:d,data:I.slice(),focusedIndex:Ie(),value:y,textField:e,valueField:n,optionsGuid:He,groupField:r.groupField,groupMode:"modern",listRef:b=>a.list=t.current.list=b,wrapperStyle:{maxHeight:x.height},wrapperCssClass:o.classNames(o.uDropDownList.listContent({c:v})),listStyle:a.enabled?{transform:D}:void 0,key:"listkey",skip:g,onClick:gt,itemRender:m,groupHeaderItemRender:u,noDataRender:c,onScroll:ft,wrapperRef:a.scrollerRef,scroller:(l=t==null?void 0:t.current)==null?void 0:l.renderScrollElement(),ariaSetSize:i.total})},vt=()=>{var y;const{windowWidth:e=0}=f,{header:n,footer:i,adaptiveTitle:u,groupField:c,groupStickyHeaderItemRender:m,list:I}=r,v=p.getFilteredData(h),a=r.opened!==void 0?r.opened:f.opened,g=N&&N.uDropDownList,d=N&&N.uDropDownsActionSheet,x={navigatable:!1,navigatableElements:[],expand:a,animation:!0,onClose:l=>he(l),animationStyles:e<=o.ADAPTIVE_SMALL_BREAKPOINT?{top:0,width:"100%",height:"100%"}:void 0,className:o.classNames(o.uDropDownsActionSheet.wrapper({c:d,isFullScreen:e<=o.ADAPTIVE_SMALL_BREAKPOINT}))};let{group:D}=f;return D===void 0&&c!==void 0&&(D=p.getItemValue(v[0],c)),s.createElement(ke.ActionSheet,{...x},s.createElement(ke.ActionSheetHeader,{className:o.classNames(o.uDropDownsActionSheet.header({c:d}))},s.createElement("div",{className:o.classNames(o.uDropDownsActionSheet.titleBar({c:d}))},s.createElement("div",{className:o.classNames(o.uDropDownsActionSheet.title({c:d}))},s.createElement("div",null,u)),s.createElement("div",{className:o.classNames(o.uDropDownsActionSheet.actions({c:d}))},s.createElement(tt.Button,{tabIndex:0,"aria-label":"Cancel","aria-disabled":"false",type:"button",fillMode:"flat",onClick:he,icon:"x",svgIcon:Ze.xIcon}))),s.createElement("div",{className:o.classNames(o.uDropDownsActionSheet.titleBarGroup({c:d}))},Ae())),s.createElement(ke.ActionSheetContent,{overflowHidden:!0},n&&s.createElement("div",{className:o.classNames(o.uDropDownList.listHeader({c:g}))},n),s.createElement("div",{className:o.classNames(o.uDropDownList.list({c:g,size:Y,virtual:(y=t==null?void 0:t.current)==null?void 0:y.vs.enabled}))},Te(),!I&&D&&v.length!==0&&s.createElement(et,{group:D,groupMode:"modern",render:m}),Oe()),i&&s.createElement("div",{className:o.classNames(o.uDropDownList.listFooter({c:g}))},i)))},Dt=()=>{f.focused&&window.setTimeout(()=>{f.focused&&t.current.wrapper&&ee(t.current.wrapper)})},wt=e=>{var n;(n=r.popupSettings)!=null&&n.onMouseDownOutside&&r.popupSettings.onMouseDownOutside.call(void 0,e)},It=()=>{const{header:e,footer:n,dir:i,groupField:u,groupStickyHeaderItemRender:c,list:m}=r,I=p.getFilteredData(h),v=t.current,a=v.getPopupSettings(),g=r.opened!==void 0?r.opened:f.opened,d=a.width!==void 0?a.width:v.popupWidth,x=N&&N.uDropDownList,D={dir:i!==void 0?i:v.dirCalculated,width:d,popupSettings:{...a,popupClass:o.classNames(a.popupClass,o.uDropDownList.listContainer({c:x})),anchor:a.anchor||H.current,show:g,onOpen:we,onClose:Dt,onMouseDownOutside:wt},itemsCount:[I.length]};let{group:y}=f;return y===void 0&&u!==void 0&&(y=p.getItemValue(I[0],u)),s.createElement(_t,{...D},Ae(),e&&s.createElement("div",{className:o.classNames(o.uDropDownList.listHeader({c:x}))},e),s.createElement("div",{className:o.classNames(o.uDropDownList.list({c:x,size:Y,virtual:t.current.vs.enabled}))},Te(),!m&&y&&I.length!==0&&s.createElement(et,{group:y,groupMode:"modern",render:c}),Oe()),n&&s.createElement("div",{className:o.classNames(o.uDropDownList.listFooter({c:x}))},n))},yt=e=>{const{dataItemKey:n}=r,i=p.getFilteredData(h),u=K();let c=i.map((k,G)=>({item:k,itemIndex:G}));const m=W.current.word,I=W.current.last,v=p.sameCharsOnly(m,I);let a=c.length,g=Math.max(0,i.findIndex(k=>p.areSame(k,u,n))),d;r.defaultItem&&(d={item:r.defaultItem,itemIndex:-1},a+=1,g+=1),g+=v?1:0,c=p.shuffleData(c,g,d);let x,D,y,l=0;const{textField:b}=r;for(;l<a;l++)if(x=p.getItemValue(c[l].item,b),D=v&&p.matchText(x,I,me),y=p.matchText(x,m,me),D||y){l=c[l].itemIndex;break}if(l!==a){const k=t.current.initState();k.syntheticEvent=e,$(l,k),P(k),T.current=void 0}},ht=e=>{clearTimeout(Ve.current),r.filterable||(Ve.current=window.setTimeout(()=>W.current.word="",ot),yt(e))},St=e=>{ne.current||t.current.handleFocus(e)},xt=e=>{if(ne.current||!f.focused)return;const n=r.opened!==void 0?r.opened:f.opened,{adaptive:i}=r,{windowWidth:u=0}=f,c=u<=o.ADAPTIVE_MEDIUM_BREAKPOINT&&i,m=t.current.initState();m.syntheticEvent=e,m.data.focused=!1,m.events.push({type:"onBlur"}),n&&ye(),n&&!c&&t.current.togglePopup(m),P(m)},Ct=e=>{if(r.filterable||e.which===0||e.keyCode===o.Keys.enter)return;let n=String.fromCharCode(e.charCode||e.keyCode);me&&(n=n.toLowerCase()),n===" "&&e.preventDefault(),W.current={word:W.current.word+n,last:W.current.last+n},ht(e)},Et=()=>{const e=t.current.initState();e.data.opened=f.opened,t.current.togglePopup(e),P(e)},qe=s.useRef(null),H=s.useRef(null),te=s.useRef(),J=s.useRef(null);s.useImperativeHandle(qe,()=>({get element(){return H.current},get index(){return it()},get name(){return r.name},get validity(){return De()},get value(){return K()},get focused(){return f.focused},get opened(){return f.opened},focus:st,props:r,togglePopup:Et})),s.useImperativeHandle(R,()=>qe.current);const Ve=s.useRef(null),W=s.useRef({word:"",last:""}),ne=s.useRef(!1),T=s.useRef(null),O=s.useRef(!1),Se=s.useRef(!1),q=s.useRef({}),re=s.useRef({}),t=s.useRef(new nt({props:h,setState:()=>{},state:{},forceUpdate:()=>{},element:null,value:null,handleItemSelect:()=>{}})),ze=s.useRef(0),Q=s.useRef(null),[f,Lt]=s.useState({}),[,Be]=s.useReducer(e=>e,!0),Nt=jt.useLocalization(),U=e=>{Lt({...f,...e})};s.useEffect(()=>{t.current.updateComponentArgs({props:h,setState:U,state:f,forceUpdate:Be,element:H.current,handleItemSelect:$,value:K()})},[U,f,Be,$,K]),s.useEffect(()=>{var g,d,x,D,y,l,b,k,G,Z,le,de,C;const{dataItemKey:e,virtual:n,groupField:i="",textField:u}=r,c=p.getFilteredData(h),m=q.current.virtual?q.current.virtual.total:0,I=r.opened!==void 0?r.opened:f.opened,v=q.current.opened!==void 0?q.current.opened:re.current.opened,a=!v&&I;if((g=t==null?void 0:t.current)==null||g.didUpdate(),(d=t==null?void 0:t.current)!=null&&d.getPopupSettings().animate||a&&we(),n&&n.total!==m)(x=t==null?void 0:t.current)==null||x.vs.calcScrollElementHeight(),(D=t==null?void 0:t.current)==null||D.vs.reset();else{const M=K(),ce=q.current.value!==void 0?q.current.value:re.current.value;let z=c.findIndex(j=>p.areSame(j,M,e));i!==""&&M&&u&&(z=(l=(y=t==null?void 0:t.current)==null?void 0:y.getGroupedDataModernMode(c,i))==null?void 0:l.map(j=>j[u]).indexOf(M[u]));const ue=!p.areSame(ce,M,e);a&&n?(b=t==null?void 0:t.current)==null||b.scrollToVirtualItem(n,z):a&&!n?(we(),c&&c.length!==0&&((k=t==null?void 0:t.current)==null||k.resetGroupStickyHeader(c[0][i],{setState:U,group:f.group,state:f})),(G=t==null?void 0:t.current)==null||G.scrollToItem(z)):I&&v&&M&&ue&&!O.current?(le=t==null?void 0:t.current)==null||le.scrollToItem(z,(Z=t==null?void 0:t.current)==null?void 0:Z.vs.enabled):I&&v&&O.current&&(O.current&&n&&n.skip===0?(de=t==null?void 0:t.current)==null||de.vs.reset():O.current&&n&&n.skip===n.total-n.pageSize&&((C=t==null?void 0:t.current)==null||C.vs.scrollToEnd()))}O.current=!1,re.current=f,q.current=r,be()}),s.useEffect(()=>{var e,n;return Q.current=o.canUseDOM&&window.ResizeObserver&&new window.ResizeObserver(i=>dt(i)),(e=t==null?void 0:t.current)==null||e.didMount(),be(),(n=fe())!=null&&n.body&&Q.current&&Q.current.observe(fe().body),()=>{var i;(i=fe())!=null&&i.body&&Q.current&&Q.current.disconnect()}},[]);const _e=B+"-accessibility-id",xe=B+"-listbox-id",He=B+"-guid",Kt=Nt.toLanguageString(Ke.dropDownListArrowBtnAriaLabel,Ke.messages[Ke.dropDownListArrowBtnAriaLabel]),{style:oe,className:kt,label:Ce,dir:Pt,virtual:V,adaptive:bt,dataItemKey:Ft,disabled:ae,loading:We,iconClassName:Ue,svgIcon:Ge,valueRender:je}=r,{windowWidth:Mt=0}=f,Ee=r.opened!==void 0?r.opened:f.opened,se=K(),Le=p.getItemValue(se,r.textField),Re=!lt()||De().valid,ie=t.current,At=ie.vs,Ye=Mt<=o.ADAPTIVE_MEDIUM_BREAKPOINT&&bt,X=N&&N.uDropDownList;At.enabled=V!==void 0,V!==void 0&&(ie.vs.skip=V.skip,ie.vs.total=V.total,ie.vs.pageSize=V.pageSize);const Tt=p.getFilteredData(h),{focused:Ot}=f,qt=Tt.findIndex(e=>p.areSame(e,se,Ft)),$e=s.createElement("span",{id:_e,className:o.classNames(o.uDropDownList.inputInner({c:X}))},Le&&s.createElement("span",{className:o.classNames(o.uDropDownList.inputText({c:X}))},Le)),Vt=je!==void 0?je.call(void 0,$e,se):$e,Je=s.createElement(s.Fragment,null,s.createElement("span",{ref:ct,className:o.classNames(o.uDropDownList.wrapper({c:X,size:Y,rounded:Pe,fillMode:ge,focused:Ot,disabled:ae,invalid:!Re,loading:We,required:ve()}),kt),style:Ce?{...oe,width:void 0}:oe,dir:Pt,onMouseDown:Ee?e=>{e.target.nodeName!=="INPUT"&&(ee(t.current.wrapper),e.preventDefault())}:void 0,onFocus:St,onBlur:xt,tabIndex:o.getTabIndex(at,ae),accessKey:r.accessKey,onKeyDown:Me,onKeyPress:Ct,onClick:ae?void 0:he,role:"combobox","aria-required":ve(),"aria-disabled":ae||void 0,"aria-haspopup":"listbox","aria-expanded":Ee||!1,"aria-owns":xe,"aria-activedescendant":Ee?"option-"+He+"-"+(qt+(V?V.skip:0)):void 0,"aria-label":r.ariaLabel||r.label,"aria-labelledby":r.ariaLabelledBy,"aria-describedby":r.ariaDescribedBy||_e,"aria-controls":xe,id:r.id,title:r.title},Vt,We&&s.createElement(o.IconWrap,{className:o.classNames(o.uDropDownList.loadingIcon({c:X})),name:"loading"}),s.createElement(tt.Button,{tabIndex:-1,type:"button","aria-label":Kt,size:Y,fillMode:ge,iconClass:Ue,className:o.classNames(o.uDropDownList.inputButton({c:X})),rounded:null,themeColor:"base",icon:Ue?void 0:"caret-alt-down",svgIcon:Ge||Ze.caretAltDownIcon,onMouseDown:e=>f.focused&&e.preventDefault()}),ut(se),!Ye&&It()),Ye&&vt());return Ce?s.createElement(Bt.FloatingLabel,{label:Ce,editorValue:Le,editorValid:Re,editorDisabled:r.disabled,style:{width:oe?oe.width:void 0},children:Je}):Je});pe.propTypes={delay:L.number,ignoreCase:L.bool,iconClassName:L.string,svgIcon:o.svgIconPropType,defaultItem:L.any,valueRender:L.func,valueMap:L.func,validationMessage:L.string,required:L.bool,id:L.string,ariaLabelledBy:L.string,ariaDescribedBy:L.string,ariaLabel:L.string,leftRightKeysNavigation:L.bool,title:L.string,groupField:L.string,list:L.any,skipDisabledItems:L.bool};const F={delay:500,tabIndex:0,ignoreCase:!0,...nt.defaultProps,required:!1,size:"medium",rounded:"medium",fillMode:"solid",groupMode:"modern"};pe.displayName="KendoReactDropDownList";const rt=o.createPropsContext();pe.displayName="KendoReactDropDownList";exports.DropDownList=pe;exports.DropDownListPropsContext=rt;exports.dropDownListDefaultProps=F;
